unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    HostEdit: TEdit;
    ReadCheck: TCheckBox;
    Label1: TLabel;
    IndexEdit: TEdit;
    ConnectButton: TButton;
    LogList: TListBox;
    DisconnectButton: TButton;
    HzEdit: TEdit;
    SetHzButton: TButton;
    DataMemo: TMemo;
    PutDataButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ConnectButtonClick(Sender: TObject);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure SetHzButtonClick(Sender: TObject);
    procedure PutDataButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

const
  //AIOEDIO = '..\AIOEDIO.dll';
  AIOEDIO = 'AIOEDIO.dll';

function AED_Connect(HostName: PChar; bReadPort: LongBool; Index: LongInt): LongWord; cdecl; external AIOEDIO;
function AED_SetFreq(uClientRef: LongWord; Hz: LongInt): LongWord; cdecl; external AIOEDIO;
function AED_SetBlockSize(uClientRef: LongWord; SizeBytes: LongInt): LongWord; cdecl; external AIOEDIO;
function AED_Go(uClientRef: LongWord): LongWord; cdecl; external AIOEDIO;
function AED_GoClear(uClientRef: LongWord): LongWord; cdecl; external AIOEDIO;
function AED_Clear(uClientRef: LongWord): LongWord; cdecl; external AIOEDIO;
function AED_SetTimeout(uClientRef: LongWord; TimeoutMS: LongInt): LongWord; cdecl; external AIOEDIO;
function AED_GetData(uClientRef: LongWord; pDataBytes: PLongInt; pData: PWord): LongWord; cdecl; external AIOEDIO;
function AED_PutData(uClientRef: LongWord; pDataBytes: PLongInt; pData: PWord): LongWord; cdecl; external AIOEDIO;
function AED_GetStatus(uClientRef: LongWord): LongWord; cdecl; external AIOEDIO;
function AED_Close(uClientRef: LongWord): LongWord; cdecl; external AIOEDIO;

var
  MyClientRef: LongWord;

procedure Log(Lin: String);
var
  I: Integer;
  WhichList: TListBox;

begin
  WhichList := MainForm.LogList;

  WhichList.Items.Insert(0, Lin);
  I := WhichList.Items.Count - 1;
  while I >= 32 do begin
    WhichList.Items.Delete(I);
    Dec(I);
  end;
  if WhichList.ItemIndex = -1 then WhichList.ItemIndex := 0;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  //`@
end;

procedure TMainForm.ConnectButtonClick(Sender: TObject);
var
  HostNom: String;
  Index: Integer;
  Status: LongWord;

begin
  HostNom := HostEdit.Text;
  Index := StrToInt(IndexEdit.Text);

  Log('Connecting...');
  MyClientRef := AED_Connect(PChar(HostNom), ReadCheck.Checked, Index);
  Status := GetLastError;
  HostNom := '';

  if MyClientRef = 0 then begin
    Log('Error ' + IntToStr(Status));
    Exit;
  end
  else
    Log('Connected, ref ' + IntToHex(MyClientRef, 8))
  ;

  Log('Going...');
  Status := AED_Go(MyClientRef);
  if Status <> ERROR_SUCCESS then
    Log('Error ' + IntToStr(Status))
  else
    Log('OK')
  ;
end;

procedure TMainForm.DisconnectButtonClick(Sender: TObject);
var
  Status: LongWord;

begin
  Log('Disconnecting...');
  Status := AED_Close(MyClientRef);
  if Status <> ERROR_SUCCESS then
    Log('Error ' + IntToStr(Status))
  else
    Log('OK')
  ;
  MyClientRef := 0;
end;

procedure TMainForm.SetHzButtonClick(Sender: TObject);
var
  Status: LongWord;
  Hz: Integer;

begin
  Hz := StrToInt(HzEdit.Text);

  Log('Setting Freq...');
  Status := AED_SetFreq(MyClientRef, Hz);
  if Status <> ERROR_SUCCESS then
    Log('Error ' + IntToStr(Status))
  else
    Log('OK')
  ;
end;

procedure TMainForm.PutDataButtonClick(Sender: TObject);
var
  Status: LongWord;
  I, DataBytes, oDataBytes: Integer;
  DIOData: array of Word;
  InterBuf: TStringList;

begin
  InterBuf := TStringList.Create;
  InterBuf.Text := DataMemo.Lines.Text;
  for I := InterBuf.Count - 1 downto 0 do
    if InterBuf[I] = '' then
      InterBuf.Delete(I)
    else
      Break
  ;
  SetLength(DIOData, InterBuf.Count);
  for I := 0 to InterBuf.Count - 1 do
    DIOData[I] := StrToInt('$' + InterBuf[I])
  ;
  InterBuf.Free;

  Log('Putting Data...');
  DataBytes := Length(DIOData) * SizeOf(DIOData[0]);
  oDataBytes := DataBytes;
  Status := AED_PutData(MyClientRef, @DataBytes, @DIOData[0]);
  if Status <> ERROR_SUCCESS then
    Log('Error ' + IntToStr(Status))
  else
    Log('OK ' + IntToStr(DataBytes) + '/' + IntToStr(oDataBytes))
  ;
end;

end.
